<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->


<div fxLayout="column" class="margin-top-x4">
  <form [formGroup]="newWksForm">

    <div fxLayout="column" fxFlex class="workspace-create margin-top-x1">
      <div fxFlex class="margin-top-x1">
        <mat-form-field appearance="outline" fxFlexFill class="add-workspace-form-field">
          <mat-label>Name</mat-label>
          <input
            #workspaceNameInput
            matInput
            type="text"
            formControlName="workspaceName"
            maxLength="100"
            [appFocusInputIfLargeScreen]="canFocus"
            [errorStateMatcher]="matcher"
            required
          >
          <mat-hint *ngIf="workspaceNameInput.value?.length !== 100; else isMaxNameLength">{{ workspaceNameInput.value?.length || 0 }}/100</mat-hint>
          <ng-template #isMaxNameLength>
            <mat-error>Max 100 characters!</mat-error>
          </ng-template>
          <span matPrefix><mat-icon class="icon-x2"><fa-icon class="far" [icon]="['far','folder']"></fa-icon></mat-icon></span>
          <mat-error *ngIf="formErrors.workspaceName">{{ formErrors.workspaceName }}</mat-error>
        </mat-form-field>
      </div>

      <div fxFlex>
        <mat-form-field appearance="outline" fxFlexFill class="add-short-description-form-field">
          <mat-label>Description (Optional)</mat-label>
          <textarea
            #txtShortDescription
            matInput
            matTextareaAutosize
            matAutosizeMinRows="4"
            maxRows="5"
            maxLength="200"
            formControlName="shortDescription"
            class="description-wks"
          ></textarea>
          <mat-hint *ngIf="txtShortDescription.value?.length !== 200; else isMaxDescLength">{{ txtShortDescription.value?.length || 0 }}/200</mat-hint>
          <ng-template #isMaxDescLength>
            <mat-error>Max 200 characters!</mat-error>
          </ng-template>
        </mat-form-field>
      </div>

      <app-message
        class="error-create-wks-details"
        type="error"
        [isFullWidth]="true"
        [msg]="msgError"
      ></app-message>

      <div fxLayout="row" fxLayoutAlign="end center" class="margin-top-x1">
        <button mat-raised-button color="primary" (click)="doSubmit()" class="btn-add-workspace" [disabled]="newWksForm.invalid || !canCreate">
          <span fxLayout="row" fxLayoutAlign="center center">
            <mat-icon fxLayoutAlign="center end" class="icon-x2 margin-right-x1"><fa-icon icon="folder-plus"></fa-icon></mat-icon>
            <span
              *ngIf="!canCreate else createTxtTpl"
              fxLayout="row"
              fxLayoutAlign="center center"
              class="text-upper"
            >
              Create
              <mat-spinner [diameter]="16" [strokeWidth]="1" class="margin-left-x1"></mat-spinner>
            </span>

            <ng-template #createTxtTpl>
              <span class="text-upper">Create</span>
            </ng-template>
          </span>
        </button>
      </div>
    </div>

  </form>
</div>
